--
-- Farmet Kompaktomat K 1570
--
-- by Defender
--

Farmet_K1570doModeChangeEvent = {};
Farmet_K1570doModeChangeEvent_mt = Class(Farmet_K1570doModeChangeEvent, Event);

InitEventClass(Farmet_K1570doModeChangeEvent, "Farmet_K1570doModeChangeEvent");

function Farmet_K1570doModeChangeEvent:emptyNew()
    local self = Event:new(Farmet_K1570doModeChangeEvent_mt);
    self.className="Farmet_K1570doModeChangeEvent";
    return self;
end;

function Farmet_K1570doModeChangeEvent:new(object)
    local self = Farmet_K1570doModeChangeEvent:emptyNew()
    self.object = object;
    return self;
end;

function Farmet_K1570doModeChangeEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    self.object = networkGetObject(id);
    self:run(connection);
end;

function Farmet_K1570doModeChangeEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
end;

function Farmet_K1570doModeChangeEvent:run(connection)
    self.object:doModeChange();
    if not connection:getIsServer() then
        g_server:broadcastEvent(Farmet_K1570doModeChangeEvent:new(self.object), nil, connection, self.object);
    end;
end;


Farmet_K1570setBrokenEvent = {};
Farmet_K1570setBrokenEvent_mt = Class(Farmet_K1570setBrokenEvent, Event);

InitEventClass(Farmet_K1570setBrokenEvent, "Farmet_K1570setBrokenEvent");

function Farmet_K1570setBrokenEvent:emptyNew()
    local self = Event:new(Farmet_K1570setBrokenEvent_mt);
    self.className="Farmet_K1570setBrokenEvent";
    return self;
end;

function Farmet_K1570setBrokenEvent:new(object, broken)
    local self = Farmet_K1570setBrokenEvent:emptyNew()
    self.object = object;
    self.broken = broken;
    return self;
end;

function Farmet_K1570setBrokenEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    self.broken = streamReadBool(streamId);
    self.object = networkGetObject(id);
    self:run(connection);
end;

function Farmet_K1570setBrokenEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
    streamWriteBool(streamId, self.broken);
end;

function Farmet_K1570setBrokenEvent:run(connection)
    self.object:setBroken(self.broken, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(Farmet_K1570setBrokenEvent:new(self.object, self.broken), nil, connection, self.object);
    end;
end;

Farmet_K1570setSafeModeEvent = {};
Farmet_K1570setSafeModeEvent_mt = Class(Farmet_K1570setSafeModeEvent, Event);

InitEventClass(Farmet_K1570setSafeModeEvent, "Farmet_K1570setSafeModeEvent");

function Farmet_K1570setSafeModeEvent:emptyNew()
    local self = Event:new(Farmet_K1570setSafeModeEvent_mt);
    self.className="Farmet_K1570setSafeModeEvent";
    return self;
end;

function Farmet_K1570setSafeModeEvent:new(object, safeMode)
    local self = Farmet_K1570setSafeModeEvent:emptyNew()
    self.object = object;
    self.safeMode = safeMode;
    return self;
end;

function Farmet_K1570setSafeModeEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    self.safeMode = streamReadBool(streamId);
    self.object = networkGetObject(id);
    self:run(connection);
end;

function Farmet_K1570setSafeModeEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
    streamWriteBool(streamId, self.safeMode);
end;

function Farmet_K1570setSafeModeEvent:run(connection)
    self.object:setSafeMode(self.safeMode, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(Farmet_K1570setSafeModeEvent:new(self.object, self.safeMode), nil, connection, self.object);
    end;
end;

Farmet_K1570setCanChangeSMEvent = {};
Farmet_K1570setCanChangeSMEvent_mt = Class(Farmet_K1570setCanChangeSMEvent, Event);

InitEventClass(Farmet_K1570setCanChangeSMEvent, "Farmet_K1570setCanChangeSMEvent");

function Farmet_K1570setCanChangeSMEvent:emptyNew()
    local self = Event:new(Farmet_K1570setCanChangeSMEvent_mt);
    self.className="Farmet_K1570setCanChangeSMEvent";
    return self;
end;

function Farmet_K1570setCanChangeSMEvent:new(object, canChangeSM)
    local self = Farmet_K1570setCanChangeSMEvent:emptyNew()
    self.object = object;
    self.canChangeSM = canChangeSM;
    return self;
end;

function Farmet_K1570setCanChangeSMEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    self.canChangeSM = streamReadBool(streamId);
    self.object = networkGetObject(id);
    self:run(connection);
end;

function Farmet_K1570setCanChangeSMEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
    streamWriteBool(streamId, self.canChangeSM);
end;

function Farmet_K1570setCanChangeSMEvent:run(connection)
    self.object:setCanChangeSM(self.canChangeSM, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(Farmet_K1570setCanChangeSMEvent:new(self.object, self.canChangeSM), nil, connection, self.object);
    end;
end;

Farmet_K1570 = {};

function Farmet_K1570.prerequisitesPresent(specializations)
    return true;
end;

function Farmet_K1570:load(xmlFile)
  print("Farmet_K1570 loading ...");
  _G.lng:loadTexts(self.baseDirectory.."modDesc.xml");
  self.doModeChange = SpecializationUtil.callSpecializationsFunction("doModeChange");
  self.setBroken = SpecializationUtil.callSpecializationsFunction("setBroken");
  self.setSafeMode = SpecializationUtil.callSpecializationsFunction("setSafeMode");
  self.setCanChangeSM = SpecializationUtil.callSpecializationsFunction("setCanChangeSM");
  self.workMode = false;
  self.turnOff = false;
  self.folding = false;
  self.unfolding = false;
  self.aiTerrainDetailChannel1 = g_currentMission.ploughChannel;
  self.aiTerrainDetailChannel2 = g_currentMission.sowingChannel;
  self.safeMode = true;
  self.canChangeSM = true;
	self.AIon = false;
	self.broken = false;
	self.repairPrice = 1000;
	self.repairCount = 0;
	self.repairAgainPrice = 500;
	self.vehicleType = getXMLString(xmlFile, "vehicle#type");	
    
  local foldAnimRootNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.unfoldAnim#rootNode"));
  self.foldAnimCharSet = 0;
  if foldAnimRootNode ~= nil and foldAnimRootNode ~= 0 then
    self.foldAnimCharSet = getAnimCharacterSet(foldAnimRootNode);
    if self.foldAnimCharSet ~= 0 then
      local clip = getAnimClipIndex(self.foldAnimCharSet, getXMLString(xmlFile, "vehicle.unfoldAnim#animationClip"));
      assignAnimTrackClip(self.foldAnimCharSet, 0, clip);
      setAnimTrackLoopState(self.foldAnimCharSet, 0, false);
      self.foldAnimSpeedScale = 1;
      self.foldAnimDuration = getAnimClipDuration(self.foldAnimCharSet, clip);
      end;
  end;
  
  local sLAnimRootNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.supportLegAnim#rootNode"));
  self.sLAnimCharSet = 0;
  if sLAnimRootNode ~= nil and sLAnimRootNode ~= 0 then
    self.sLAnimCharSet = getAnimCharacterSet(sLAnimRootNode);
    if self.sLAnimCharSet ~= 0 then
      local clip1 = getAnimClipIndex(self.sLAnimCharSet, getXMLString(xmlFile, "vehicle.supportLegAnim#animationClip"));
      assignAnimTrackClip(self.sLAnimCharSet, 0, clip1);
      setAnimTrackLoopState(self.sLAnimCharSet, 0, false);
      self.sLAnimSpeedScale = 1;
      self.sLAnimDuration = getAnimClipDuration(self.sLAnimCharSet, clip1);
      end;
  end;
  
  local numSpinnerParts = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.SpinnerParts#count"), 0);
  self.SpinnerParts = {};
  for i=1, numSpinnerParts do
    local partnamei = string.format("vehicle.SpinnerParts.part" .. "%d", i);
    self.SpinnerParts[i] = {};
    self.SpinnerParts[i].index = Utils.indexToObject(self.components, getXMLString(xmlFile, partnamei .. "#index"));
    self.SpinnerParts[i].Scale = Utils.getNoNil(getXMLInt(xmlFile, partnamei .. "#rotScale"), 10);
  end;
  self.rotationSpeed = 0;
  self.rotationSpeedDownRate = 0;
  self.lastMovingDirection = 0;

  if self.isClient then
    local workSound = getXMLString(xmlFile, "vehicle.workSound#file");
    if workSound ~= nil and workSound ~= "" then
      workSound = Utils.getFilename(workSound, self.baseDirectory);
      self.workSound = createSample("workSound");
      self.workSoundEnabled = false;
      loadSample(self.workSound, workSound, false);
      self.workSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#pitchOffset"), 1);
      self.workSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#volume"), 1);
    end;
    self.dustParticleSystems = {};
    local dustParticleSystemCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.dustParticleSystems#count"), 0);
    for i=1, dustParticleSystemCount do
      local namei = string.format("vehicle.dustParticleSystems.part%d", i);
      local nodei = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, namei .. "#index"));
      Utils.loadParticleSystem(xmlFile, self.dustParticleSystems, namei, nodei, false, nil, self.baseDirectory)
    end;
  end;
  
  
  self.saveAILM = self.aiLeftMarker;
  self.aiLeftMarker = nil;
  self.speedViolationMaxTime = 5000;
  self.speedViolationTimer = self.speedViolationMaxTime;
end;

function Farmet_K1570:delete()
  if self.isClient then
	  Utils.setEmittingState(self.dustParticleSystems, false)
	  if self.workSoundEnabled then
		  stopSample(self.workSound);
		  self.workSoundEnabled = nil;
    end;
  end;
end;

function Farmet_K1570:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
  self.broken = Utils.getNoNil(getXMLBool(xmlFile, key.."#broken"), false);
  self.repairCount = Utils.getNoNil(getXMLInt(xmlFile, key.."#repairCount"), 0);
  return BaseMission.VEHICLE_LOAD_OK;
end;

function Farmet_K1570:getSaveAttributesAndNodes(nodeIdent)
  local attributes = 'broken="'..tostring(self.broken)..'" repairCount="'..tostring(self.repairCount)..'"';
  return attributes, nil;
end;

function Farmet_K1570:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Farmet_K1570:keyEvent(unicode, sym, modifier, isDown)
end;

function Farmet_K1570:readStream(streamId, timestamp, connection)
  self.workMode = streamReadBool(streamId);
  self.turnOff = streamReadBool(streamId);
  self.folding = streamReadBool(streamId);
  self.unfolding = streamReadBool(streamId);
  self.canChangeSM = streamReadBool(streamId);
  self.safeMode = streamReadBool(streamId);
	self.AIon = streamReadBool(streamId);
	self.broken = streamReadBool(streamId);
	self.repairCount = streamReadInt16(streamId);
end;

function Farmet_K1570:writeStream(streamId, connection, dirtyMask)
  streamWriteBool(streamId, self.workMode);
  streamWriteBool(streamId, self.turnOff);
  streamWriteBool(streamId, self.folding);
  streamWriteBool(streamId, self.unfolding);
  streamWriteBool(streamId, self.canChangeSM);
  streamWriteBool(streamId, self.safeMode);
	streamWriteBool(streamId, self.AIon);
	streamWriteBool(streamId, self.broken);
	streamWriteInt16(streamId, self.repairCount);
end;


function Farmet_K1570:update(dt)
  if self.isClient then
    if self.broken then
      if getUserInRange(self.rootNode, 6) then
        local price = self.repairPrice + (self.repairAgainPrice * self.repairCount);
        g_currentMission:addExtraPrintText(_G.lng:getText("klavesa").." O"..":              ".._G.lng:getText("repeair").." ("..tostring(price*g_i18n.currencyFactor).." "..g_i18n:getText("Currency_symbol")..")");
        if g_currentMission.missionStats.money < price then
          g_currentMission:addExtraPrintText(_G.lng:getText("no_money"));
        else
          if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
            g_currentMission.missionStats.money=g_currentMission.missionStats.money-price;
            self:setBroken(false);
          end;
        end;
      end;
    end;
    if self.attacherVehicle then
  		if self.attacherVehicle.isAITractorActivated ~= nil then
  			self.AIon = self.attacherVehicle.isAITractorActivated;
  			if not self.AIon then
  			  self.turnOff = false;
        end;
  		end;
      if self:getIsActiveForInput() then
        if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
          self:doModeChange();
          if g_server ~= nil then
              g_server:broadcastEvent(Farmet_K1570doModeChangeEvent:new(self), nil, nil, self);
          else
              g_client:getServerConnection():sendEvent(Farmet_K1570doModeChangeEvent:new(self));
          end;
        end;
        if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
          self:setSafeMode(not self.safeMode);
        end;
      end;

      if self.unfolding and getAnimTrackTime(self.foldAnimCharSet, 0) >= self.foldAnimDuration then
        local a = Utils.degToRad(-3);
        local a1 = Utils.degToRad(3);
        setJointRotationLimit(self.componentJoints[2].jointIndex, 0, true, a, a1);
        self.unfolding = false;
        self.workMode = true;
        self.aiLeftMarker = self.saveAILM;
        AITractor.updateToolsInfo(self.attacherVehicle);
      end;

      if self.workMode then
        if self.attacherVehicle~=nil and self:doCheckSpeedLimit() and self.attacherVehicle.lastSpeed * 3600 > 20 then
          self.speedViolationTimer = self.speedViolationTimer - dt;
          if self.speedViolationTimer < 0 and self.attacherVehicle~=nil then
            self:setBroken(true);
          end;
        else
          self.speedViolationTimer = self.speedViolationMaxTime;
        end;

        if self.attacherVehicle ~= nil then
          self.rotationSpeed = self.attacherVehicle.lastSpeed * self.attacherVehicle.movingDirection;
        else
          self.rotationSpeed = 0;
        end;

        self.rotationSpeedDownRate = math.abs(self.rotationSpeed * 0.02);
        if self.attacherVehicle~=nil then
          self.lastMovingDirection = self.attacherVehicle.movingDirection;
        end;
        self.rotationSpeed = self.rotationSpeed - self.rotationSpeedDownRate;
        local rotS = self.rotationSpeed * 1000;
        if rotS == 0 or self.turnOff then
          if rotS == 0 then
            self.rotationSpeed = 0;
          end;
          Utils.setEmittingState(self.dustParticleSystems, false)
          if self.workSoundEnabled then
            stopSample(self.workSound);
            self.workSoundEnabled = nil;
          end;
        else
          Utils.setEmittingState(self.dustParticleSystems, true)
          if not self.workSoundEnabled and not self.AIon then
            setSamplePitch(self.workSound, self.workSoundPitchOffset);
            playSample(self.workSound, 0, self.workSoundVolume, 0);
            self.workSoundEnabled = true;
          end;
        end;
        for i=1, table.getn(self.SpinnerParts) do
          rotate(self.SpinnerParts[i].index , self.SpinnerParts[i].Scale * self.rotationSpeed ,0,0);
        end;
      end;
    end;
    if self.folding or self.unfolding then
      setJointFrame(self.componentJoints[2].jointIndex, 0,self.componentJoints[2].jointNode);
      setJointFrame(self.componentJoints[3].jointIndex, 0,self.componentJoints[3].jointNode);
      setJointFrame(self.componentJoints[4].jointIndex, 0,self.componentJoints[4].jointNode);
      setJointFrame(self.componentJoints[6].jointIndex, 0,self.componentJoints[6].jointNode);
      setJointFrame(self.componentJoints[8].jointIndex, 0,self.componentJoints[8].jointNode);
      local d = 0;
      local d1 = 0;
      local t = getAnimTrackTime(self.foldAnimCharSet, 0);
      if t>9750 then
        d = -3;
        d1 = 3;
      elseif t>9500 then
        d = -2;
        d1 = 2;
      elseif t>9250 then
        d = -1;
        d1 = 1;
      elseif t>9000 then
        d = -0.5;
        d1 = 0.5;
      end;
      local r = Utils.degToRad(d);
      local r1 = Utils.degToRad(d1);
      for i=3, 8 do
        setJointRotationLimit(self.componentJoints[i].jointIndex, 2, true, r, r1);
      end;
    end;

    local tm = getAnimTrackTime(self.sLAnimCharSet, 0);
    if (tm>0) and (tm<self.sLAnimDuration) then
      local joint = self.componentJoints[1];
      setJointFrame(joint.jointIndex, 0,joint.jointNode);
    end;
    if self.folding and getAnimTrackTime(self.foldAnimCharSet, 0) <= 0 then
      self.folding = false;
    end;
  end;
  if self.isServer then
    if self.attacherVehicle then
      if self.broken then
        self.attacherVehicle:detachImplementByObject(self);
      end;
    end;
    local canChangeSM = true;
    if not g_currentMission.allowClientsCreateFields then
      local owner = self:getOwner();
      if ((owner ~= nil) and not owner:getIsLocal()) then
        canChangeSM = false;
      end;
    end;
    
    if self.canChangeSM ~= canChangeSM then
      self:setCanChangeSM(canChangeSM);
    end;

    if not self.safeMode and not canChangeSM then
      self:setSafeMode(true);
    end;
    if self.workMode then
      if not self.turnOff  and not self.broken then
        local cuttingAreasSend = {};
        local cA;
        if self.AIon then
          cA = self.cuttingAreas[2];
        else
          cA = self.cuttingAreas[1];
        end;
        local x,y,z = getWorldTranslation(cA.start);
        local x1,y1,z1 = getWorldTranslation(cA.width);
        local x2,y2,z2 = getWorldTranslation(cA.height);

        table.insert(cuttingAreasSend, {x,z,x1,z1,x2,z2});
        
        if table.getn(cuttingAreasSend) > 0 then
          CultivatorAreaEvent.runLocally(cuttingAreasSend, self.safeMode);
          g_server:broadcastEvent(CultivatorAreaEvent:new(cuttingAreasSend, self.safeMode));
        end;
      end;
    end;
  end;

end;

function Farmet_K1570:setCanChangeSM(canChangeSM, noEventSend)
  if canChangeSM ~= self.canChangeSM then
    self.canChangeSM = canChangeSM;
    if noEventSend == nil or noEventSend == false then
      if g_server ~= nil then
        g_server:broadcastEvent(Farmet_K1570setCanChangeSMEvent:new(self, canChangeSM), nil, nil, self);
      else
        g_client:getServerConnection():sendEvent(Farmet_K1570setCanChangeSMEvent:new(self, canChangeSM));
      end;
    end;
  end;
end;

function Farmet_K1570:setSafeMode(safeMode, noEventSend)
  if safeMode ~= self.safeMode then
    self.safeMode = safeMode;
    if noEventSend == nil or noEventSend == false then
      if g_server ~= nil then
        g_server:broadcastEvent(Farmet_K1570setSafeModeEvent:new(self, safeMode), nil, nil, self);
      else
        g_client:getServerConnection():sendEvent(Farmet_K1570setSafeModeEvent:new(self, safeMode));
      end;
    end;
  end;
end;

function Farmet_K1570:setBroken(broken, noEventSend)
  if broken ~= self.broken then
    self.broken = broken;
    if noEventSend == nil or noEventSend == false then
      if g_server ~= nil then
        g_server:broadcastEvent(Farmet_K1570setBrokenEvent:new(self, broken), nil, nil, self);
      else
       g_client:getServerConnection():sendEvent(Farmet_K1570setBrokenEvent:new(self, broken));
      end;
    end;
    if not self.broken then
      self.repairCount = self.repairCount + 1;
    end;
  end;
end;

function Farmet_K1570:doModeChange()
  if not self.workMode and not self.unfolding then
    if getAnimTrackTime(self.foldAnimCharSet, 0) < 0.0 then
      setAnimTrackTime(self.foldAnimCharSet, 0, 0.0);
    end;
    setAnimTrackSpeedScale(self.foldAnimCharSet, 0, self.foldAnimSpeedScale);
    enableAnimTrack(self.foldAnimCharSet, 0);
    self.folding=false;
    self.unfolding=true;
  else
    local d = Utils.degToRad(0);
    setJointRotationLimit(self.componentJoints[2].jointIndex, 0, true, d, d);
    Utils.setEmittingState(self.dustParticleSystems, false)
    if self.workSoundEnabled then
      stopSample(self.workSound);
      self.workSoundEnabled = nil;
    end;
    if getAnimTrackTime(self.foldAnimCharSet, 0) > self.foldAnimDuration then
      setAnimTrackTime(self.foldAnimCharSet, 0, self.foldAnimDuration);
    end;
    setAnimTrackSpeedScale(self.foldAnimCharSet, 0, -self.foldAnimSpeedScale);
    enableAnimTrack(self.foldAnimCharSet, 0);
    self.workMode = false;
    self.aiLeftMarker = nil;
    AITractor.updateToolsInfo(self.attacherVehicle);
    self.folding=true;
    self.unfolding=false;
  end;
end;

function Farmet_K1570:draw()
  if self.workMode or self.unfolding then
    g_currentMission:addExtraPrintText(_G.lng:getText("klavesa").." X"..":                   ".._G.lng:getText("fold_kompaktomat"));
  else
    g_currentMission:addExtraPrintText(_G.lng:getText("klavesa").." X"..":                   ".._G.lng:getText("unfold_kompaktomat"));
  end;

  if self.canChangeSM then
    if self.safeMode then
      g_currentMission:addExtraPrintText(_G.lng:getText("klavesa").." B"..":                   ".._G.lng:getText("turn_safe_off"));
    else
      g_currentMission:addExtraPrintText(_G.lng:getText("klavesa").." B"..":                   ".._G.lng:getText("turn_safe_on"));
    end;
  else
    g_currentMission:addExtraPrintText(_G.lng:getText("cant_make_safe_off1"));
    g_currentMission:addExtraPrintText(_G.lng:getText("cant_make_safe_off2"));
  end;
  if math.abs(self.speedViolationTimer - self.speedViolationMaxTime) > 2 then
    g_currentMission:addWarning(g_i18n:getText("Dont_drive_to_fast") .. "\n" .. string.format(g_i18n:getText("Cruise_control_levelN"), "1", InputBinding.getKeyNamesOfDigitalAction(InputBinding.SPEED_LEVEL1)), 0.092, 0.048)
  end
end;

function Farmet_K1570:aiLower()
  if not self.safeMode then
    self.turnOff = false;
  end;
end; 


function Farmet_K1570:aiRaise()
  if not self.safeMode then
    self.turnOff = true;
  end;
end;

function Farmet_K1570:onDeactivate() 
  self.speedViolationTimer = self.speedViolationMaxTime;
  if self.isClient then
    Utils.setEmittingState(self.dustParticleSystems, false)
    if self.workSoundEnabled then
      stopSample(self.workSound);
      self.workSoundEnabled = nil;
    end;
  end;
end;

function Farmet_K1570:onDetach()
  self:onDeactivate();
  if self.isClient then
    if getAnimTrackTime(self.sLAnimCharSet, 0) > self.sLAnimDuration then
      setAnimTrackTime(self.sLAnimCharSet, 0, self.sLAnimDuration);
    end;
    setAnimTrackSpeedScale(self.sLAnimCharSet, 0, -self.sLAnimSpeedScale);
    enableAnimTrack(self.sLAnimCharSet, 0);
  end;
end;

function Farmet_K1570:onAttach()
  if self.isClient then
    if getAnimTrackTime(self.sLAnimCharSet, 0) < 0 then
      setAnimTrackTime(self.sLAnimCharSet, 0, 0.0);
    end;
    setAnimTrackSpeedScale(self.sLAnimCharSet, 0, self.sLAnimSpeedScale);
    enableAnimTrack(self.sLAnimCharSet, 0);
  end;
end;

function getUserInRange(node, minDistance)
  local result = false; 
  local px, py, pz = getWorldTranslation(node);
  if g_currentMission.player.isEntered then
    local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
    local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
    if distance < minDistance then		
      result = true;
    end;
  end;
  return result;
end;
